package br.usp.poli.java.ihc;
/*
Copyright (C) 2008 Fbio Levy Siqueira (fabiolevy@yahoo.com.br)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
import javax.swing.*;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

@SuppressWarnings("serial")
class Menu extends JMenuBar {
	private Truco janelaPai;
	private JMenuItem iniciar, abortar, sair;
	
	Menu(Truco janelaPai) {
		this.janelaPai = janelaPai;
		iniciar = new JMenuItem("Iniciar", KeyEvent.VK_I);
		abortar = new JMenuItem("Abortar", KeyEvent.VK_B);
		sair = new JMenuItem("Sair", KeyEvent.VK_S);
	}
	
	void iniciar() {
		this.add(criarMenuJogo());
		this.add(criarMenuAjuda());
	}
	
	private JMenu criarMenuJogo() {
		JMenu menuJogo = new JMenu("Jogo");
		menuJogo.setMnemonic(KeyEvent.VK_J);
		
		// Criando a ao de iniciar
		iniciar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				SwingUtilities.invokeLater(new Runnable() {
				    public void run() {
						TelaInicioJogo tela = new TelaInicioJogo(janelaPai);
						
						tela.escolherJogadores();
						
						if (!tela.foiCancelado()) {
							InfoJogador[] jogadores = tela.jogadores();
							iniciar.setEnabled(false);
							abortar.setEnabled(true);
							janelaPai.comecarJogo(tela.eJogoManilhaFixa(), jogadores[0].getNome(), jogadores[0].isAutomatico(), jogadores[1].getNome(), jogadores[1].isAutomatico());
						}
				    }
				});
			}
		});
		
		if (janelaPai.getJogoManilhaFixa() == null && janelaPai.getJogoManilhaVariavel() == null)
			iniciar.setEnabled(false);
		
		abortar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				SwingUtilities.invokeLater(new Runnable() {
				    public void run() {
						janelaPai.abortar();
						iniciar.setEnabled(true);
						abortar.setEnabled(false);
				    }
				});
			}
		});
		abortar.setEnabled(false);
		
		// Criando a ao de Sair
		sair.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// saindo...
				System.exit(0);
			}
		});
		
		menuJogo.add(iniciar);
		menuJogo.add(abortar);
		menuJogo.addSeparator();
		menuJogo.add(sair);
		
		return menuJogo;
	}
	
	void reiniciar() {
		iniciar.setEnabled(true);
		abortar.setEnabled(false);
	}
	
	private JMenu criarMenuAjuda() {
		JMenu menuAjuda = new JMenu("Ajuda");
		menuAjuda.setMnemonic(KeyEvent.VK_A);
		
		JMenuItem sobre = new JMenuItem("Sobre", KeyEvent.VK_S);
		sobre.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				TelaSobre sobre = new TelaSobre(janelaPai);
				sobre.mostrar();
			}
		});
		
		menuAjuda.add(sobre);
		
		return menuAjuda;		
	}
}
